CIM XML Toolkit
===============

The CIM XML Toolkit consists of six submodules which can be separated into two
groups:
* The actual CIM++ Deserializer
  * [CIM-Deserializer](#CIM-Deserializer)
* Maintenance tools/code
  * [CIM-Include-Tool](#CIM-Include-Tool)
  * [CIMRefactorer](#CIMRefactorer)
  * [CIMUnmarshallingGenerator](#CIMUnmarshallingGenerator)
  * [GeneratedCode](#GeneratedCode)
  * [Refactoring-Script](#Refactoring-Script)


## CIM-Deserializer<a name="CIM-Deserializer"></a>
The CIM-Deserializer submodule contains the actual CIM++ Deserializer. In most cases
you want to check out this submodule and use the CIM++ Deserializer right away. For
information about how to build and use the CIM++ Deserializer take a look at the
submodules [README](https://git.rwth-aachen.de/CIM-XML-Interface/CIM-Deserializer/blob/master/README).


## Maintenance tools
The maintenance tools are used to update the CIM++ Deserializer to new CIM versions.
These usually come as Enterprise Architect project files (.eap) which then can
be used to generate CIM C++ code. For information how to generate the CIM C++
Code please refer to [HOWTO](#howtoEA). Since this code cannot be used right
away one will need to run the Refactoring-Script to modify and repair the code.
After modifying, the code can be used in the CIM++ Deserializer source.

### Refactoring-Script submodule<a name="Refactoring-Script"></a>
The Refactoring-Script submodule contains a bash shell script that controls the
update process. It will call the CIM-Include-Tool and the CIMRefactorer. Before
the refactoring script can be used make sure that these tools are built and
the script is properly configured to run on the current platform. To do so open
the script with a text editor.

### CIM-Include-Tool submodule<a name="CIM-Include-Tool"></a>
The CIM-Include-Tool is one of the two tools necessary to modify the CIM C++
code. Please refer to the submodules
[README](https://git.rwth-aachen.de/CIM-XML-Interface/CIM-Include-Tool/blob/master/README.md)
about how to build the tool.

### CIMRefactorer submodule<a name="CIMRefactorer"></a>
The CIMRefactorer submodule contains a refactoring tool required by the
refactoring script. It requires llvm/clang libraries to be installed on the
target platform. Please refer to the submodules
[README](https://git.rwth-aachen.de/CIM-XML-Interface/CIMRefactorer/blob/master/README.md)
about how to build the tool.

### GeneratedCode submodule<a name="GeneratedCode"></a>
The GeneratedCode submodule is used to store different versions of CIM C++ Code
which are generated using the UML modeling tool Enterprise Architect. There are
several branches that can be used for different purposes. For example the branch
[ready_for_cim_parser](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/ready_for_cim_parser)
can be directly used within the CIM++ Deserializer and shell be updated with each new
CIM version. The following table gives an overview about the branches and their use. Note, the branches usually wont be merged into each other!

#### Branches to use
| Branch | Description |
| -------- | -------- |
| [unmodified](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/unmodified) | Unmodified code generated by Enterprise Architect |
| [ready_to_use](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/ready_to_use) | Code after running refactoring script |
| [ready_for_cim_parser](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/ready_for_cim_parser)| Code after adding BaseClass for CIM++ Deserializer |

#### Patch branches
These branches are used to generate the patches for the refactoring script.

| Branch | Description |
| -------- | -------- |
| [fix001](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix001) | Fixed forward declaration problem in [IdentifiedObject.h](IEC61970/Base/Core/IdentifiedObject.h) |
| [fix002](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix002) | Fixed misinterpretation of decimal values in [Currency.h](IEC61970/Base/Domain/Currency.h) |
| [fix003](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix003) | Fixed Forward Declaration error in [ValueAliasSet.h](IEC61970/Base/Meas/ValueAliasSet.h) |
| [fix004](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix004) | Fixed error wich using c++ keyword in code |
| [fix005](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix005) | Fixed [Damping.cpp](IEC61970/Base/Domain/Damping.cpp) |
| [fix006](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix006) | Implementation of datatypes |
| [fix007](https://git.rwth-aachen.de/CIM-XML-Interface/GeneratedCode/tree/fix007) | Fixed errors caused by CIM-XML-Interface/CIMRefactorer#5 |

### CIMUnmarshallingGenerator submodule<a name="CIMUnmarshallingGenerator"></a>
The CIMUnmarshallingGenerator submodule contains the tools which parses the CIM
C++ code in order to generate source files for the CIM++ Deserializer.
Please refer to the submodules [README](https://git.rwth-aachen.de/CIM-XML-Interface/CIMUnmarshallingGenerator/blob/master/README.md) about how to build the
tool.

## How to update the CIM C++ code
To update the CIM C++ code follow these steps:
1. Generate C++ code using the UML modeling tool Enterprise Architect
2. Run the refactoring script
3. Apply BaseClass patch

```bash
cd <GeneratedCode>
patch -p1 < Refactoring-Script/Patches/BaseClass.patch
```
4. Run the CIMUnmarshallingGenerator to generate CIM++ Deserializer source files
5. Copy the generated CIM source files (folder IEC61970) into the source
    directory of the CIM++ Deserializer (CIM-Deserializer/src). Overwrite previous version
    if necessary
6. Copy the generated deserializer source files into CIM++ Deserializer source as well
7. Test if the deserializer still works as desired

### How to generate CIM C++ code with Enterprise Architect<a name="howtoEA"></a>
Skip steps 1 to 7 if CIM xmi file is already imported and available as
Enterprise Architect project (*.eap).

In general this is loosely referring to [Enterprise Architect User Guide - Generate Package ](http://www.sparxsystems.com/enterprise_architect_user_guide/9.0/software_engineering/generateapackage.html) and [Enterprise Architect User Guide - Reset Options](http://www.sparxsystems.com/enterprise_architect_user_guide/9.0/software_engineering/resetoptions.html)

#### Import xmi file
1. Open Enterprise Architect and create new empty project.
  Do not add anything to the project jet!
2. Right click into project browser then select `Import Model from XMI...`
3. Select CIM xmi file
4. Uncheck `Import using single transaction`
5. Change `Treat Imported Datatypes` to `Code:C++`
6. Press `Import`
7. Confirm to place model as root

##### InfIEC61970 Workaround
The subpackage InfIEC61970 contains several headers which require forward
decalration of some classes. For now this package is not used and can therefore
be deleted.
1. In project browser right click `InfIEC61970` and select `Delete ...`

#### Set code generation options
8. Open Tools/Options. Navigate to `Source Code Engineering`, click on `Code
  Page for source` and select `65001 (UFT-8)`. Deselect `Output files use both CR & LF`.
9. Check the box `Create dependencies for operation returns and parameter types`
9. Navigate to `C++` and click on `Collection Classes` and set `Default
  Collection Class` to `std::list<#TYPE#*>`. Set `Generate Namespaces` to `True`.
10. In project browser right click on `TC57CIM` and select `Code Engineering/Set as Namespace Root`
11. In project browser right click on `TC57CIM` and select `Code Engineering/Reset Options for this Package`
12. Set `Where language is` to `<All>` and `Convert to` to `C++`
13. Check `Process Child Packages` and hit `OK` and confirm conversion

#### Generate C++ code
14. In project browser right click on `IEC61970` and select `Code Engineering/Generate Source Code`
15. Set `Synchronize` to `Overwrite code`
16. Check `Auto Generate files` and select destination folder
17. Check `Include all Child Packages`
18. Hit `Generate`
